package dev.shadowsoffire.apotheosis.potion;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import dev.shadowsoffire.apotheosis.Apoth;
import dev.shadowsoffire.apotheosis.potion.PotionCharmItem;
import dev.shadowsoffire.placebo.recipe.RecipeHelper;
import it.unimi.dsi.fastutil.ints.IntArrayList;
import it.unimi.dsi.fastutil.ints.IntList;
import java.util.ArrayList;
import java.util.List;
import java.util.stream.Collectors;
import net.minecraft.core.NonNullList;
import net.minecraft.core.RegistryAccess;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.world.Container;
import net.minecraft.world.inventory.CraftingContainer;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.Items;
import net.minecraft.world.item.alchemy.Potion;
import net.minecraft.world.item.alchemy.PotionUtils;
import net.minecraft.world.item.crafting.CraftingBookCategory;
import net.minecraft.world.item.crafting.Ingredient;
import net.minecraft.world.item.crafting.RecipeSerializer;
import net.minecraft.world.item.crafting.ShapedRecipe;
import net.minecraft.world.level.ItemLike;
import net.minecraft.world.level.Level;
import net.minecraftforge.registries.ForgeRegistries;

public class PotionCharmRecipe extends ShapedRecipe {
  protected final IntList potionSlots = (IntList)new IntArrayList();
  
  protected final Ingredient potion = makePotionIngredient();
  
  public PotionCharmRecipe(List<Object> ingredients, int width, int height) {
    super(new ResourceLocation("apotheosis", "potion_charm"), "", CraftingBookCategory.MISC, width, height, makeIngredients(ingredients), new ItemStack((ItemLike)Apoth.Items.POTION_CHARM.get()));
    for (int i = 0; i < ingredients.size(); i++) {
      if ("potion".equals(ingredients.get(i)))
        this.potionSlots.add(i); 
    } 
  }
  
  private static Ingredient makePotionIngredient() {
    List<ItemStack> potionStacks = new ArrayList<>();
    for (Potion p : ForgeRegistries.POTIONS) {
      if (!PotionCharmItem.isValidPotion(p))
        continue; 
      ItemStack potion = new ItemStack((ItemLike)Items.f_42589_);
      PotionUtils.m_43549_(potion, p);
      potionStacks.add(potion);
    } 
    return Ingredient.m_43927_(potionStacks.<ItemStack>toArray(new ItemStack[0]));
  }
  
  private static NonNullList<Ingredient> makeIngredients(List<Object> ingredients) {
    List<Object> realIngredients = new ArrayList();
    Ingredient potion = makePotionIngredient();
    for (Object o : ingredients) {
      if ("potion".equals(o)) {
        realIngredients.add(potion);
        continue;
      } 
      realIngredients.add(o);
    } 
    return RecipeHelper.createInput("apotheosis", true, realIngredients.toArray());
  }
  
  public Ingredient getPotionIngredient() {
    return this.potion;
  }
  
  public IntList getPotionSlots() {
    return this.potionSlots;
  }
  
  public ItemStack m_5874_(CraftingContainer inv, RegistryAccess regs) {
    ItemStack out = super.m_5874_(inv, regs);
    PotionUtils.m_43549_(out, PotionUtils.m_43579_(inv.m_8020_(4)));
    return out;
  }
  
  public boolean m_5818_(CraftingContainer inv, Level world) {
    if (super.m_5818_(inv, world)) {
      List<Potion> potions = (List<Potion>)this.potionSlots.intStream().mapToObj(s -> inv.m_8020_(s)).map(PotionUtils::m_43579_).collect(Collectors.toList());
      if (potions.size() > 0 && potions.stream().allMatch(PotionCharmItem::isValidPotion))
        return (potions.stream().distinct().count() == 1L); 
    } 
    return false;
  }
  
  public RecipeSerializer<?> m_7707_() {
    return (RecipeSerializer<?>)Serializer.INSTANCE;
  }
}
